//$JOBCRD  JOB (001),'JOBCRD SUBROUTINE',CLASS=S,MSGCLASS=X             00010000
//JOBCRD  EXEC ASMFCL,PARM.ASM='LIST,LOAD,NODECK',                      00020000
//             MAC1='SYS1.AMODGEN'                                      00030000
//ASM.SYSIN DD *                                                        00070000
JOBCRD   CSECT                         DEFINE CSECT                     00071000
*********************************************************************** 00072000
*                                                                       00073000
*    ROUTINE NAME ---------> JOBCRD                                     00074000
*                                                                       00075000
*    ENTRY POINTS ---------> -NONE-                                     00076000
*                                                                       00077000
*    EXTERNAL REFERENCES --> -NONE-                                     00078000
*                                                                       00079000
*    PARMS ----------------> JOBNAME  -  8 BYTE JOBNAME                 00079100
*                            MSGCLASS -  1 BYTE MESSAGE CLASS           00079200
*                            PRIORITY -  2 BYTE INTEGER PRIORITY        00079300
*                            REGION   -  2 BYTE INTEGER REGION          00079400
*                                          (IN KBYTES)                  00079500
*                            TIME     -  4 BYTE INTEGER TIME LIMIT      00079600
*                                          (IN HUNDREDTHS OF SECONDS)   00079700
*                            NAME     - 20 BYTE PROGRAMMER NAME         00079800
*                            ACCOUNT  -  N BYTE ACCOUNTING FIELD        00079900
*                            ACCTLEN  -  2 BYTE INTEGER ACNT FIELD LEN  00080000
*                            ROOM     -  N BYTE ROOM FIELD              00080100
*                            ROOMLEN  -  2 BYTE INTEGER ROOM FIELD LEN  00080200
*                            JOBCLASS -  1 BYTE JOB CLASS               00080300
*                            JES#     -  4 JES NUMBER                   00080400
*                                        (THIS PARM IS OPTIONAL)        00080500
*                                                                       00080600
*    DATE LAST MODIFIED ---> 10/20/81                                   00080700
*                                                                       00080800
*    ROUTINE DESCRIPTION:                                               00080900
*         THIS ROUTINE RETURNS INFORMATION FROM THE JOB CARD OF         00081000
*    THE EXECUTING JOB.                                                 00081100
*                                                                       00081200
*                                                                       00081300
*********************************************************************** 00081400
*                                                                       00081500
*     REGISTER EQUATES AND USAGE                                        00081600
*                                                                       00081700
R0       EQU   0                                                        00081800
R1       EQU   1                                                        00081900
R2       EQU   2                                                        00082000
R3       EQU   3                                                        00082100
R4       EQU   4                                                        00082200
R5       EQU   5                                                        00082300
R6       EQU   6                                                        00082400
R7       EQU   7                                                        00082500
R8       EQU   8                       TCT, THEN JMR ADDR               00082600
R9       EQU   9                       ACT ADDR                         00082700
R10      EQU   10                      JCT ADDR                         00082800
R11      EQU   11                      WORKAREA BASE REG                00082900
R12      EQU   12                      BASE REG                         00083000
R13      EQU   13                      SAVE AREA ADDR                   00083100
R14      EQU   14                      RETURN ADDR                      00083200
R15      EQU   15                      RETURN CODE                      00083300
*                                                                       00083400
*     HOUSEKEEPING                                                      00083500
*                                                                       00083600
         STM   R14,R12,12(R13)         SAVE REGISTERS                   00083700
         LR    R12,R15                 SET REG 12 TO ENTRY ADDR         00083800
         USING JOBCRD,R12              ESTABLISH ADDRESSABILITY         00083900
         LR    R10,R1                  SAVE R1                          00084000
         LR    R2,R13                  SAVE ADDR OF CALLING SAVE AREA   00084100
         GETMAIN RU,LV=WORKSIZE        GET SOME CORE                    00084200
         LR    R13,R1                  SAVE ADDR OF CORE OBTAINED       00084300
         USING WORKAREA,R13            ESTABLISH ADDRESSABILITY         00084400
         ST    R2,SAVEAREA+4           STORE ADDR OF CALLING SAVE AREA  00084500
         ST    R13,8(R2)               STORE ADDR OF MY SAVE AREA       00084600
*                                                                       00084700
*     SAVE PARAMETER ADDRESSES                                          00084800
*                                                                       00084900
         MVC   PARMPTRS(PARMLEN),0(R10)    SAVE PARAMETER ADDRESSES     00085000
*                                                                       00085100
*     GET INFO FROM JOBCARD (JCT)                                       00085200
*                                                                       00085300
         USING PSA,R0                  ADDRESSABLILTY TO PSA            00085400
         L     R10,PSATOLD             GET MY TCB ADDR                  00085500
         DROP  R0                      FORGET PSA                       00085600
         USING TCB,R10                 ADDRESSABLILTY TO TCB            00085700
         L     R8,TCBTCT               LOAD ADDR OF TCT                 00085800
         L     R10,TCBJSCB             LOAD ADDR OF JSCB                00085900
         DROP  R10                     FORGET TCB                       00086000
         USING IEZJSCB,R10             ADDRESSABLILTY TO JSCB           00086100
         L     R10,JSCBJCT             LOAD ADDR OF JCT                 00086200
         DROP  R10                     FORGET JSCB                      00086300
         LA    R10,16(R10)             SKIP OVER 16 BYTE JCT PREFIX     00086400
         USING INJMJCT,R10             ADDRESSABILITY TO JCT            00086500
         L     R2,JOBNPTR              LOAD ADDR OF JOBNAME    PARM     00086600
         MVC   0(8,R2),JCTJNAME        PASS IT BACK TO CALLING GUY      00086700
         L     R2,MSGCPTR              LOAD ADDR OF MSGCLASS   PARM     00086800
         MVC   0(1,R2),JCTJMGPO        PASS IT BACK TO CALLING GUY      00086900
         L     R2,PRTYPTR              LOAD ADDR OF PRIORITY   PARM     00087000
         IC    R3,JCTJPRTY             LOAD MSGLEVEL & PRIORITY         00087100
         N     R3,=X'0000000F'         TURN OFF ALL BUT LAST NIBBLE     00087200
         STH   R3,0(R2)                PASS IT BACK TO CALLING GUY      00087300
         L     R2,REGNPTR              LOAD ADDR OF REGION     PARM     00087400
         MVC   0(2,R2),92(R10)         PASS IT BACK TO CALLING GUY      00087500
         L     R2,TIMEPTR              LOAD ADDR OF TIME       PARM     00087600
         SLR   R3,R3                   ZERO R3                          00087700
         ICM   R3,7,JCTJMRTL           LOAD TIME LIMIT                  00087800
         ST    R3,0(R2)                PASS IT BACK TO CALLING GUY      00087900
*                                                                       00088000
*     GET INFO FROM ACT                                                 00088100
*                                                                       00088200
         SLR   R9,R9                   ZERO R9                          00088300
         ICM   R9,7,JCTACTAD           LOAD 3 BYTE ACT ADDRESS          00088400
         LA    R9,16(R9)               SKIP OVER 16 BYTE ACT PREFIX     00088500
         DROP  R10                                                      00088600
         USING IEFAACTB,R9             ADDRESSABILITY TO ACT            00088700
         L     R2,NAMEPTR              LOAD ADDR OF NAME       PARM     00088800
         MVC   0(20,R2),ACTPRGNM       PASS IT BACK TO CALLING GUY      00088900
*                                                                       00089000
*     LOCATE AND RETURN FIRST ACCOUNTING FIELD                          00089100
*                                                                       00089200
         CLI   ACTJNFLD,1              NUMBER OF ACCOUNTING FIELDS      00089300
         BL    NOACCT1                 BRANCH IF <1                     00089400
         CLI   ACTJNFLD+1,1            CHECK LENGTH OF FIRST FIELD      00089500
         BL    NOACCT1                 BRANCH IF <1                     00089600
         SLR   R4,R4                   ZERO R4                          00089700
         IC    R4,ACTJNFLD+1           LOAD LENGTH OF FIELD             00089800
         L     R2,ACTLPTR              LOAD ADDR OF ACNT LEN   PARM     00089900
         STH   R4,0(R2)                PASS IT BACK TO CALLING GUY      00090000
         LR    R5,R4                   COPY LENGTH                      00090100
         BCTR  R5,0                    DECREMENT LENGTH FOR EX          00090200
         L     R2,ACCTPTR              LOAD ADDR OF ACCOUNT    PARM     00090300
         EX    R5,MOVEACCT             PASS IT BACK TO CALLING GUY      00090400
         B     GETROOM                 GO GET ROOM                      00090500
NOACCT1  EQU   *                                                        00090600
         L     R2,ACTLPTR              LOAD ADDR OF ACNT LEN   PARM     00090700
         MVC   0(2,R2),=H'0'           PASS IT BACK TO CALLING GUY      00090800
*                                                                       00090900
*     LOCATE AND RETURN SECOND ACCOUNTING FIELD                         00091000
*                                                                       00091100
GETROOM  EQU   *                                                        00091200
         CLI   ACTJNFLD,2              NUMBER OF ACCOUNTING FIELDS      00091300
         BL    NOACCT2                 BRANCH IF <2                     00091400
         LA    R6,ACTJNFLD+2(R4)       COMPUTE ADDR OF 2ND FIELD LEN    00091500
         CLI   0(R6),1                 CHECK LENGTH OF SECOND FIELD     00091600
         BL    NOACCT2                 BRANCH IF <1                     00091700
         SLR   R7,R7                   ZERO R7                          00091800
         IC    R7,0(R6)                LOAD LENGTH OF FIELD             00091900
         L     R2,ROMLPTR              LOAD ADDR OF ROOM LEN   PARM     00092000
         STH   R7,0(R2)                PASS IT BACK TO CALLING GUY      00092100
         BCTR  R7,0                    DECREMENT LENGTH FOR EX          00092200
         L     R2,ROOMPTR              LOAD ADDR OF ROOM       PARM     00092300
         EX    R7,MOVEROOM             MOVE IN 2ND FIELD                00092400
         B     ENDROOM                                                  00092500
NOACCT2  EQU   *                                                        00092600
         L     R2,ROMLPTR              LOAD ADDR OF ROOM LEN   PARM     00092700
         MVC   0(2,R2),=H'0'           PASS IT BACK TO CALLING GUY      00092800
ENDROOM  EQU   *                                                        00092900
*                                                                       00093000
*     GET STUFF FROM JMR                                                00093100
*                                                                       00093200
         USING SMFTCT,R8               ADDRESSABILITY TO TCT            00093300
         L     R8,TCTJMR               LOAD ADDR OF JMR                 00093400
         DROP  R8                      FORGET TCT                       00093500
         USING JMR,R8                  ADDRESSABILITY TO JMR            00093600
         L     R2,CLASPTR              LOAD ADDR OF JOB CLASS  PARM     00093700
         MVC   0(1,R2),JMRCLASS        PASS IT BACK TO CALLING GUY      00093800
         LTR   R2,R2                   IS CLASS THE LAST PARM?          00093900
         BM    NOJES                   YES, DON'T RETURN JES NUMBER     00094000
         L     R2,JES#PTR              LOAD ADDR OF JES NUMBER PARM     00094100
         MVC   0(4,R2),JMRUSEID+4      PASS IT BACK TO CALLING GUY      00094200
NOJES    EQU   *                                                        00094300
         L     R8,16              R8 -> CVT                       *JLM* 00094400
         L     R8,0(,R8)             -> TCBWORDS                  *JLM* 00094500
         L     R8,4(,R8)             -> TCB                       *JLM* 00094600
         L     R8,180(,R8)           -> JSCB (TCBJSCB)            *JLM* 00094700
         L     R8,348(,R8)           -> ACTIVE JSCB (JSCBACT)     *JLM* 00094800
         ICM   R8,15,316(R8)         -> SSIB (JSCBSSIB)           *JLM* 00094900
         BZ    NOJES2             SKIP IF NO LIFE-OF-JOB SSIB     *JLM* 00095000
         MVC   0(4,R2),16(R8)     COPY JOB NUMBER (SSIBJBID)      *JLM* 00095100
NOJES2   EQU   *                                                  *JLM* 00095200
*                                                                       00095300
*     TERMINATE                                                         00095400
*                                                                       00095500
         LR    R1,R13                  SAVE PTR TO GETMAINED SAVE AREA  00095600
         LR    R2,R15                  SAVE RETURN CODE                 00095700
         L     R13,SAVEAREA+4          LOAD ADDR OF CALLING SAVE AREA   00095800
         FREEMAIN R,LV=WORKSIZE,A=(R1) FREE THE CORE WE GOT             00095900
         LR    R15,R2                  PUT RETURN CODE IN R15           00096000
         L     R14,12(R13)             RESTORE R14                      00096100
         LM    R0,R12,20(R13)          RESTORE R0 THROUGH R12           00096200
         BR    R14                     RETURN                           00096300
*                                                                       00096400
*     CONSTANTS                                                         00096500
*                                                                       00096600
MOVEACCT MVC   0(0,R2),ACTJNFLD+2      MOVE IN FIRST ACCOUNTING FIELD   00096700
MOVEROOM MVC   0(0,R2),1(R6)           MOVE IN SECOND ACCOUNTING FIELD  00096800
*                                                                       00096900
*     DSECTS                                                            00097000
*                                                                       00097100
WORKAREA DSECT                                                          00097200
SAVEAREA DS    18F                                                      00097300
PARMPTRS DS    0F                                                       00097400
JOBNPTR  DS    F                                                        00097500
MSGCPTR  DS    F                                                        00097600
PRTYPTR  DS    F                                                        00097700
REGNPTR  DS    F                                                        00097800
TIMEPTR  DS    F                                                        00097900
NAMEPTR  DS    F                                                        00098000
ACCTPTR  DS    F                                                        00098100
ACTLPTR  DS    F                                                        00098200
ROOMPTR  DS    F                                                        00098300
ROMLPTR  DS    F                                                        00098400
CLASPTR  DS    F                                                        00098500
JES#PTR  DS    F                                                        00098600
PARMLEN  EQU   *-PARMPTRS                                               00098700
WORKSIZE EQU   *-WORKAREA                                               00098800
         PRINT NOGEN                                                    00098900
         IHAPSA   ,                    MAP THE PSA                      00099000
         IKJTCB   ,                    MAP THE TCB                      00099100
         IEZJSCB  ,                    MAP THE JSCB                     00099200
         IEFAJCTB ,                    MAP THE JCT (AND ACT)            00099300
         IEFJMR   ,                    MAP THE JMR                      00099400
         IEFTCT   ,                    MAP THE TCT                      00099500
         END   JOBCRD                                                   00099600
//LKED.SYSLMOD DD DSN=SYS2.OBJLIB,DISP=SHR   <-- TARGET LIBRARY         00099700
//LKED.SYSIN DD *                                                       00099800
  NAME JOBCRD(R)                                                        00100000
//                                                                      00110000
